// $Id: terminal.lsl,v 1.1 2009/01/14 02:20:11 ssm2017binder Exp $
// @version SlUser
// @package Terminal
// @copyright Copyright wene / ssm2017 Binder (C) 2007-2008. All rights reserved.
// @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
// SlUser is free software and parts of it may contain or be derived from the GNU General Public License
// or other free or open source software licenses.

// **********************
//      USER PREFS
// **********************
// url ex: string url = "http://test.com";
string url = "";
// password
string password = "0000";
// infos
integer display_info = 1;
// update speed
integer update_speed = 30;
// busy time
integer busy_time = 30;
// **********************
//  DRUPAL VERSION URL
// **********************
string url2 = "/secondlife";
// **********************
//              STRINGS
// **********************
// === common ===
string _RESET = "Reset";
string _CHOOSE_AN_OPTION = "Choose an option";
string _SCRIPT_WILL_STOP = "The script will stop";
string _ENTERING_WAIT_MODE = "Entering wait mode";
// === user ===
string _REGISTER = "Register";
string _CHECKING_THE_REGKEY = "Checking the reg key";
string _ENTER_YOUR_REG_CODE_PLEASE = "Enter your reg code please";
string _SORRY_BUT_ONLY_ONE_USER = "Sorry but only one user can use the terminal at a time";
// === terminal ===
string _REGISTERING_THE_TERMINAL = "Registering the terminal";
string _UPDATING_THE_TERMINAL = "Updating the terminal";
// === terminal status ===
string _TERMINAL_IS_DISABLED = "Terminal is disabled";
string _TERMINAL_IS_ENABLED = "Terminal is enabled";
string _TERMINAL_IS_BUSY = "Terminal is busy";
// ===================================================
//          NOTHING SHOULD BE CHANGED UNDER THIS LINE
// ===================================================
// **********************
//      VARS
// **********************
key owner;
string owner_name;
key rpc_channel;
integer update_time;
integer act_time;
// menu
integer menu_listener;
integer menu_channel;
// user
key actual_user = NULL_KEY;
integer request_time;
integer listener;
// **********************
//      CALL THE MENU
// **********************
callMenu(key dest, string question, list choice)
{
    menu_listener = llListen(menu_channel,"", dest,"");
    llDialog(dest, question+" : ", choice, menu_channel);
}
// ************************************
//      GIVE VALUES TO OTHER SCRIPT
// ************************************
giveParams()
{
    string params = url+url2+";"+password+";"+(string)display_info+";"+(string)update_speed;
    llMessageLinked(LINK_THIS, 0, params, (key)"giveParams");
}
// **************************
//      SET MESSSAGE
// **************************
setMessage(string status)
{
    string message = "";
    if (status == "enabled")
    {
        llListenRemove(listener);
        actual_user = NULL_KEY;
        message = _TERMINAL_IS_ENABLED;
    }
    else if (status == "disabled")
    {
        message = _TERMINAL_IS_DISABLED;
    }
    else if (status == "busy")
    {
        message = _TERMINAL_IS_BUSY;
    }
    llSetText(message, <0.,1.,0.>, 1.);
}
// **************************
//      MANAGE LISTENERS
// **************************
list listeners = [];
addListener(key userKey)
{
    integer listener = llListen(0,"",userKey,"");
    listeners = (listeners=[]) + listeners + [listener];
    listeners = (listeners=[]) + listeners + [userKey];
}
// **********************
//          HTTP
// **********************
// register terminal
key registerTerminalId;
registerTerminal()
{
    if ( display_info )
    {
        llOwnerSay(_REGISTERING_THE_TERMINAL);
    }
    // building password
    integer keypass = (integer)llFrand(9999)+1;
    string md5pass = llMD5String(password, keypass);
    registerTerminalId = llHTTPRequest( url+url2, [HTTP_METHOD, "POST", HTTP_MIMETYPE, "application/x-www-form-urlencoded"],
                        "app=sluser"
                        +"&cmd=registerTerminal"
                        +"&output_type=message"
                        +"&arg="
                        +"password="+md5pass+":"
                        +"keypass="+(string)keypass);
}
// update terminal
key updateTerminalId;
updateTerminal()
{
    if ( display_info )
    {
        llOwnerSay(_UPDATING_THE_TERMINAL);
    }
    // building password
    integer keypass = (integer)llFrand(9999)+1;
    string md5pass = llMD5String(password, keypass);
    updateTerminalId = llHTTPRequest( url+url2, [HTTP_METHOD, "POST", HTTP_MIMETYPE, "application/x-www-form-urlencoded"],
                        "app=sluser"
                        +"&cmd=updateTerminal"
                        +"&output_type=message"
                        +"&arg="
                        +"password="+md5pass+":"
                        +"keypass="+(string)keypass+":"
                        +"rpc_channel="+(string)rpc_channel);
}
// check reg key
key checkRegKeyId;
checkRegKey(key userKey, string regKey)
{
    if ( display_info )
    {
        llOwnerSay(_CHECKING_THE_REGKEY);
    }
    checkRegKeyId = llHTTPRequest( url+url2, [HTTP_METHOD, "POST", HTTP_MIMETYPE, "application/x-www-form-urlencoded"],
                        "app=sluser"
                        +"&cmd=checkRegKey"
                        +"&output_type=message"
                        +"&arg="
                        +"user_key="+ (string)userKey+":"
                        +"user_name="+ llKey2Name(userKey)+":"
                        +"reg_key="+ regKey);
}
// ************************
//    CHECK REGISTRATION
// ************************
default
{
    on_rez(integer nbr)
    {
        llResetScript();
    }
    state_entry()
    {
        // setup vars
        owner = llGetOwner();
        owner_name = llKey2Name(owner);
        menu_channel = llFloor(llFrand(100000.0)) + 1000;
        // set message
        setMessage("disabled");
    }
    touch_start(integer total_number)
    {
        if ( llDetectedKey(0) == owner )
        {
            callMenu(owner, _CHOOSE_AN_OPTION, [_RESET, _REGISTER]);
        }
    }
    listen(integer channel, string name, key id, string message)
    {
        if ( channel == menu_channel )
        {
            if ( message == _RESET )
            {
                llResetScript();
            }
            else if ( message == _REGISTER )
            {
                registerTerminal();
            }
            llListenRemove(menu_listener);
        }
    }
    http_response(key request_id, integer status, list metadata, string body)
    {
        // get the values
        body = llStringTrim( body , STRING_TRIM);
        list values = llParseStringKeepNulls(body,[";"],[]);
        string msg = llList2String(values, 0);
        string value = llList2String(values, 1);

        if ( request_id == registerTerminalId )
        {
            if ( msg == "success" )
            {
                llOwnerSay(value);
                state run;
            }
            else if ( msg == "error" )
            {
                llOwnerSay(value);
                llOwnerSay(_SCRIPT_WILL_STOP);
                return;
            }
        }
    }
}
// ************************
//            WAIT MODE
// ************************
state run
{
    on_rez(integer nbr)
    {
        llResetScript();
    }
    state_entry()
    {
        setMessage("enabled");
        update_time = llGetUnixTime() + update_speed;
        llOwnerSay(_ENTERING_WAIT_MODE);
        llSetTimerEvent(1);
    }
    touch_start(integer total_number)
    {
        key toucher = llDetectedKey(0);
        if ( toucher == owner )
        {
            callMenu(owner, _CHOOSE_AN_OPTION, [ _RESET]);
        }
        else
        {
            if (actual_user == NULL_KEY)
            {
                setMessage("busy");
                actual_user = toucher;
                llInstantMessage(toucher, _ENTER_YOUR_REG_CODE_PLEASE);
                request_time = llGetUnixTime();
                listener = llListen(0, "", toucher, "");
            }
            else
            {
                llInstantMessage(toucher, _SORRY_BUT_ONLY_ONE_USER);
            }
        }
    }
    listen(integer channel, string name, key id, string message)
    {
        if ( channel == menu_channel )
        {
            if ( id == owner )
            {
                if ( message == _RESET )
                {
                    llResetScript();
                }
            }
        }
        else if (channel == 0)
        {
            llInstantMessage(id, _CHECKING_THE_REGKEY);
            setMessage("enabled");
            checkRegKey(id, message);
        }
    }
    http_response(key request_id, integer status, list metadata, string body)
    {
        // get values
        body = llStringTrim( body , STRING_TRIM);
        list values = llParseStringKeepNulls(body, [";"], []);
        string msg = llList2String(values, 0);
        string value = llList2String(values, 1);

        if ( display_info )
        {
            if ( request_id == checkRegKeyId )
            {
                list data = llParseStringKeepNulls(value, ["|"], []);
                string message = llList2String(data, 0);
                string userKey = llList2String(data, 1);
                if ( msg == "success")
                {
                    llOwnerSay(value);
                    llInstantMessage((key)userKey, message);
                }
                else if ( msg == "error" )
                {
                    llOwnerSay(value);
                    llInstantMessage((key)userKey, message);
                }
            }
            else
            {
                if ( msg == "success" || msg == "error" )
                {
                    llOwnerSay(value);
                }
                else
                {
                    llOwnerSay(body);
                }
            }
        }
    }
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "getParams")
        {
            giveParams();
        }
    }
    timer()
    {
        act_time = llGetUnixTime();
        if ((act_time - request_time) >= busy_time)
        {
            setMessage("enabled");
        }
        if (act_time >= update_time)
        {
            update_time = act_time + update_speed;
            llOpenRemoteDataChannel();
        }
    }
    remote_data(integer type, key channel, key message_id, string sender, integer ival, string sval) 
    {
        if ( type & REMOTE_DATA_CHANNEL )
        {
            rpc_channel = channel;
            updateTerminal();
        }
        else if (type & REMOTE_DATA_REQUEST)
        {
            list values = llParseString2List(sval, [";"], []);
            string command = llList2String(values, 0);
            string answer;
            if ( command == "check status" )
            {
                answer = "online";
            }
            llRemoteDataReply(channel, message_id, answer, 1);
        }
    }
}