<?php
// $Id: sluser.inworld.inc,v 1.1 2009/01/14 02:20:11 ssm2017binder Exp $
/**
 * @package	SlUser
 * @copyright	Copyright (C) 2009 Wene / ssm2017 Binder (S.Massiaux). All rights reserved.
 * @license		GNU/GPL, http://www.gnu.org/licenses/gpl-2.0.html
 * SlUser is free software. This version may have been modified pursuant to the GNU General Public License,
 * and as distributed it includes or is derivative of works licensed under the GNU General Public License
 * or other free or open source software licenses.
 */

/**
* Route commands
*/
function sluser_inworld_controller($cmd, &$sl, $args) {
  $response = array();
  switch ($cmd) {
    case 'registerTerminal':
    case 'updateTerminal':
      $response = sluser_register_terminal($sl, $args);
      break;

    case 'checkRegKey':
      $response = sluser_check_reg_key($sl, $args);
      break;

    default:
      $response['status'] = FALSE;
      $response['message'] = "Oops! Unknown command: $cmd.";
      break;
  }
  $sl->response['status'] = $response['status'];
  $sl->response['message'] = $response['message'];
}

/**
* Check password
*/
function sluser_check_terminal_password($password, $key) {
  if ($password == md5(variable_get('sluser_terminals_password', "0000").':'.$key)) {
    return TRUE;
  }
  return FALSE;
}

/**
* Register the terminal
*/
function sluser_register_terminal(&$sl, $args) {
  $response = array();

  // check the password
  if (!sluser_check_terminal_password($args['password'], $args['keypass'])) {
    $response['status'] = FALSE;
    $response['message'] = 'error;'. t('Wrong password.');
    return $response;
  }

  $values = array(
    'name'      =>$sl->objectname,
    'uuid'        =>$sl->objectkey,
    'region'     =>$sl->region_name,
    'position'  =>strtr($sl->position, array('(' =>'', ')' =>'', ',' =>'/', ' '=>'')),
    'rpc_channel' =>$args['rpc_channel']
  );
  $registered = sluser_store_terminal($values);
  $response['status'] = $registered['status'];
  $response['message'] = $registered['message'];
  return $response;
}

/**
* Check the user's reg key
*/
function sluser_check_reg_key($sl, $args) {
  $response = array();

  $user_key = $args['user_key'];
  $user_name = $args['user_name'];

  // get the user
  $values = array(
    'reg_key' =>$args['reg_key']
  );
  $sluser = sluser_load_sluser($values);
  if (!$sluser->id) {
    $response['status'] = FALSE;
    $response['message'] = 'error;'. t('Could not find user.').'|'.$user_key;
    return $response;
  }

  // add values to the user
  $values = array(
    'uid' => $sluser->uid,
    'name' => $user_name,
    'uuid' => $user_key,
    'reg_key' =>$args['reg_key']
  );
  $registered = sluser_store_sluser($values);

  // change the role for the user
  $values = array(
    'uid'     =>$sluser->uid,
    'roles'   =>array_filter(variable_get('sluser_default_roles', array()))
  );
  $account = new stdclass;
  $account->uid = $sluser->uid;
  $account = user_save($account, $values);
  if (!$account) {
    $response['status'] = FALSE;
    $response['message'] = "error;". t("Error saving user account.").'|'. $user_key;
    return $response;
  }
  
  $response['status'] = $registered['status'];
  $response['message'] = $registered['message'].'|'. $user_key;
  return $response;
}